local SR_WeaponBuffs = SpellReminder:NewModule("SR_WeaponBuffs","AceEvent-3.0")

function SR_WeaponBuffs:OnDisable()
	self:UnregisterAllEvents()
end

function SR_WeaponBuffs:OnEnable()
	self:RegisterEvent('UNIT_INVENTORY_CHANGED',function(unit) if unit == "player" then self:ScheduleTimer('ProcessWeaponBuffs',0.5) end end)
end

function SR_WeaponBuffs:ProcessWeaponBuffs()
	local playerName, playerGUID = UnitName("player"), UnitGUID('player')
	local now = GetTime()
	
	hasMainHandEnchant, mainHandExpiration, mainHandCharges, hasOffHandEnchant, offHandExpiration, offHandCharges, hasThrownEnchant, thrownExpiration, thrownCharges = GetWeaponEnchantInfo()

	local eventName = SpellReminder:GetEventName('MainHandEnchant',playerGUID)
	if hasMainHandEnchant then
		local name = 'wep:'..SpellReminder:GetTempBuffName(GetInventorySlotInfo("MainHandSlot"))
		local timeLeft = mainHandExpiration/1000
		local iconTexture = GetInventoryItemTexture("player", GetInventorySlotInfo("MainHandSlot"))
		
		local info = SpellReminder.chardb.char.spellSetup[name]
		local displayName = info and info.displayName or nil
		local rank = nil
		local duration = math.ceil(mainHandExpiration/1000)
		local timeStarted = math.floor(now - ((info and info.d or duration) - timeLeft))
		
		local castingInfo = SpellReminder:GetCastingObject(name,displayName,rank,playerName,playerGUID,timeStarted,duration,nil,eventName,info and info.c or nil,"buff",iconTexture)
		castingInfo.applications = mainHandCharges
		self:TrackSpell(castingInfo,true)
		SpellReminder:SetSpellCategory(name,'Weapon Buffs')
	else
		SpellReminder:CleanUp(eventName)
	end

	local eventName = SpellReminder:GetEventName('OffHandEnchant',playerGUID)
	if hasOffHandEnchant then
		local name = 'wep:'..SpellReminder:GetTempBuffName(GetInventorySlotInfo("SecondaryHandSlot"))--((string.find(self:GetTempBuffName(GetInventorySlotInfo("MainHandSlot")),".* Totem") == nil) and "Weapon Buff") or "Weapon Buff (Totem)"
		local timeLeft = offHandExpiration/1000
		local iconTexture = GetInventoryItemTexture("player", GetInventorySlotInfo("SecondaryHandSlot"))
		
		local info = SpellReminder.chardb.char.spellSetup[name]
		local displayName = info and info.displayName or nil
		local rank = nil
		local duration = math.ceil(offHandExpiration/1000)
		local timeStarted = math.floor(now - ((info and info.d or duration) - timeLeft))
		
		local castingInfo = SpellReminder:GetCastingObject(name,displayName,rank,playerName,playerGUID,timeStarted,duration,nil,eventName,info and info.c or nil,"buff",iconTexture)
		castingInfo.applications = offHandCharges
		self:TrackSpell(castingInfo,true)
		SpellReminder:SetSpellCategory(name,'Weapon Buffs')
	else
		SpellReminder:CleanUp(eventName)
	end
end